/*
 * $Id: setshow.h,v 3.37 1992/05/28 03:31:19 woo Exp woo $
 *
 * $Log: setshow.h,v $
 * Revision 3.37  1992/05/28  03:31:19  woo
 * bug fix of runaway gnuplot_x11.c, SUN util.c, xlib driver & new hidden line removal routines
 *
 * Revision 3.35  1992/03/31  04:49:54  woo
 * BETA 1 of version 3.3 - bug fixes to binary routines
 *
 * Revision 3.35  1992/03/31  04:49:54  woo
 * BETA 1 of version 3.3 - bug fixes to binary routines
 *
 * Revision 3.29  1992/03/16  00:10:19  woo
 * add discrete contour levels
 *
 * Revision 3.24  1992/02/29  16:23:41  woo
 * gnuplot3.2, beta 4
 *
 * Revision 3.23  1992/02/21  20:18:16  woo
 * gnuplot3.2, beta 3
 *
 */

/* GNUPLOT - setshow.h */
/*
 * Copyright (C) 1986, 1987, 1990, 1991, 1992   Thomas Williams, Colin Kelley
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for any purpose with or without fee is hereby granted, 
 * provided that the above copyright notice appear in all copies and 
 * that both that copyright notice and this permission notice appear 
 * in supporting documentation.
 *
 * Permission to modify the software is granted, but not the right to
 * distribute the modified code.  Modifications are to be distributed 
 * as patches to released version.
 *  
 * This software is provided "as is" without express or implied warranty.
 * 
 *
 * AUTHORS
 * 
 *   Original Software:
 *     Thomas Williams,  Colin Kelley.
 * 
 *   Gnuplot 2.0 additions:
 *       Russell Lang, Dave Kotz, John Campbell.
 *
 *   Gnuplot 3.0 additions:
 *       Gershon Elber and many others.
 * 
 * Send your comments or suggestions to 
 *  info-gnuplot@ames.arc.nasa.gov.
 * This is a mailing list; to join it send a note to 
 *  info-gnuplot-request@ames.arc.nasa.gov.  
 * Send bug reports to
 *  bug-gnuplot@ames.arc.nasa.gov.
 */

 /*
 * global variables to hold status of 'set' options
 *
 */
extern BOOLEAN			autoscale_r[MAX_WIN];
extern BOOLEAN			autoscale_t[MAX_WIN];
extern BOOLEAN			autoscale_u[MAX_WIN];
extern BOOLEAN			autoscale_v[MAX_WIN];
extern BOOLEAN			autoscale_x[MAX_WIN];
extern BOOLEAN			autoscale_y[MAX_WIN];
extern BOOLEAN			autoscale_z[MAX_WIN];
extern BOOLEAN			autoscale_lt[MAX_WIN];
extern BOOLEAN			autoscale_lu[MAX_WIN];
extern BOOLEAN			autoscale_lv[MAX_WIN];
extern BOOLEAN			autoscale_lx[MAX_WIN];
extern BOOLEAN			autoscale_ly[MAX_WIN];
extern BOOLEAN			autoscale_lz[MAX_WIN];
extern double			boxwidth[MAX_WIN];
extern BOOLEAN			clip_points[MAX_WIN];
extern BOOLEAN			clip_lines1[MAX_WIN];
extern BOOLEAN			clip_lines2[MAX_WIN];
extern BOOLEAN			draw_border[MAX_WIN];
extern BOOLEAN			draw_surface[MAX_WIN];
extern char                     dummy_var_win[MAX_WIN][MAX_NUM_VAR][MAX_ID_LEN+1];
extern char			xformat[MAX_WIN][MAX_ID_LEN+1];
extern char			yformat[MAX_WIN][MAX_ID_LEN+1];
extern char			zformat[MAX_WIN][MAX_ID_LEN+1];
extern enum PLOT_STYLE data_style[MAX_WIN], func_style[MAX_WIN];
extern BOOLEAN			grid[MAX_WIN];
extern int			key[MAX_WIN];
extern double			key_x[MAX_WIN], 
                                key_y[MAX_WIN], 
                                key_z[MAX_WIN]; 
                                /* user specified position for key */
extern BOOLEAN			log_x[MAX_WIN], log_y[MAX_WIN], log_z[MAX_WIN];
extern BOOLEAN			parametric[MAX_WIN];
extern BOOLEAN			polar[MAX_WIN];
extern int			angles_format[MAX_WIN];
extern BOOLEAN			hidden3d[MAX_WIN];
extern int			below[MAX_WIN];
extern int			below_line[MAX_WIN];
extern int			mapping3d[MAX_WIN];
extern int			samples[MAX_WIN];
extern int			iso_samples[MAX_WIN];
extern float			surface_rot_z[MAX_WIN];
extern float			surface_rot_x[MAX_WIN];
extern float			surface_scale[MAX_WIN];
extern float			surface_zscale[MAX_WIN];
extern char			title[MAX_WIN][MAX_LINE_LEN+1];
extern char			xlabel[MAX_WIN][MAX_LINE_LEN+1];
extern char			ylabel[MAX_WIN][MAX_LINE_LEN+1];
extern char			zlabel[MAX_WIN][MAX_LINE_LEN+1];
extern int			title_xoffset[MAX_WIN];
extern int			title_yoffset[MAX_WIN];
extern int			xlabel_xoffset[MAX_WIN];
extern int			xlabel_yoffset[MAX_WIN];
extern int			ylabel_xoffset[MAX_WIN];
extern int			ylabel_yoffset[MAX_WIN];
extern int			zlabel_xoffset[MAX_WIN];
extern int			zlabel_yoffset[MAX_WIN];
extern double			loff[MAX_WIN],
                                roff[MAX_WIN],
                                toff[MAX_WIN],
                                boff[MAX_WIN];
extern double	                rmin_win[MAX_WIN], rmax_win[MAX_WIN],
                                tmin_win[MAX_WIN], tmax_win[MAX_WIN],
	                        umin_win[MAX_WIN], umax_win[MAX_WIN],
	                        vmin_win[MAX_WIN], vmax_win[MAX_WIN],
	                        xmin_win[MAX_WIN], xmax_win[MAX_WIN],
	                        ymin_win[MAX_WIN], ymax_win[MAX_WIN],
	                        zmin_win[MAX_WIN], zmax_win[MAX_WIN];
extern int			draw_contour[MAX_WIN];
extern int			contour_pts[MAX_WIN];
extern int			contour_kind[MAX_WIN];
extern int			contour_order[MAX_WIN];
extern int			contour_levels[MAX_WIN];
extern int			levels_kind[MAX_WIN];
extern double		levels_list[MAX_WIN][MAX_DISCRETE_LEVELS];

extern double  zero[MAX_WIN]; /* zero threshold, not 0! */
extern BOOLEAN xzeroaxis[MAX_WIN];
extern BOOLEAN yzeroaxis[MAX_WIN];

extern BOOLEAN xtics[MAX_WIN];
extern BOOLEAN ytics[MAX_WIN];
extern BOOLEAN ztics[MAX_WIN];

extern float ticslevel[MAX_WIN];

extern struct ticdef xticdef[MAX_WIN];
extern struct ticdef yticdef[MAX_WIN];
extern struct ticdef zticdef[MAX_WIN];

extern BOOLEAN	tic_in[MAX_WIN];

extern struct text_label *first_label;
extern struct arrow_def *first_arrow;

extern BOOLEAN			timedate;
extern char			dummy_var[MAX_NUM_VAR][MAX_ID_LEN+1];
extern FILE*			outfile;
extern char			outstr[];
extern float			xsize; /* scale factor for size */
extern float			ysize; /* scale factor for size */
extern float			zsize; /* scale factor for size */
extern int			term; /* unknown term is 0 */
extern char			term_options[];
extern int			time_xoffset;
extern int			time_yoffset;
extern double			rmin, rmax;
extern double			tmin, tmax, umin, umax, vmin, vmax;
extern double			xmin, xmax, ymin, ymax, zmin, zmax;

extern struct text_label *first_label;
extern struct arrow_def *first_arrow;

/* The set and show commands, in setshow.c */
extern void set_command();
extern void show_command();
/* and some accessible support functions */
extern enum PLOT_STYLE get_style();
extern BOOLEAN load_range();
extern void show_version();
